unit UnitGlowna;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Spin;

type
  TFormaGlowna = class(TForm)
    ImageOsc: TImage;
    ScrollBarOsc: TScrollBar;
    ButtonStart: TButton;
    Timer1: TTimer;
    ButtonStop: TButton;
    Label1: TLabel;
    ButtonExport: TButton;
    ButtonAbout: TButton;
    SaveDialog1: TSaveDialog;
    CheckBoxMaxFreq: TCheckBox;
    TimerPokazujacy: TTimer;
    SpinEditFreq: TSpinEdit;
    GroupBoxSelPort: TGroupBox;
    ComboBoxPort: TComboBox;
    LabelSelPort: TLabel;
    ButtonOK: TButton;
    CheckBoxPrzeliczaj: TCheckBox;
    EditPrzeliczaj: TEdit;
    LabelPrzeliczaj: TLabel;
    GroupBox1: TGroupBox;
    TriggerCheckBox: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    MinUEdit: TEdit;
    MaxUEdit: TEdit;
    procedure ScrollBarOscChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonExportClick(Sender: TObject);
    procedure ButtonAboutClick(Sender: TObject);
    procedure TimerPokazujacyTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonOKClick(Sender: TObject);
    procedure TriggerCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
    procedure WyswietlFragment;
    function AC:byte;
    function ACwart(b:byte):real;
  public
     ComH:THandle;
    { Public declarations }
  end;

var
  FormaGlowna: TFormaGlowna;


implementation

uses o;

{$R *.DFM}

const
 EditPos:longint=0;
 CurrPos:longint=0;
 Lprobek=100000;

var
 tablProbek:array[0..Lprobek]of byte;
 tablCzasow:array[0..Lprobek]of word;
 THID,TH: DWORD;
 BierzacaLprobek:longint;
 StartTime:real;
 REF:real;
 wyzwalanie : boolean; // obsuga wyzwalania

function TFormaGlowna.AC:byte;
var
 i,w:byte;
 m:cardinal;
begin
 w:=0;
 EscapeCommFunction(ComH,SETDTR);
 SetCommBreak(ComH);
 EscapeCommFunction(ComH,CLRDTR);
 for i:=7 DownTo 0 do begin
  SetCommBreak(ComH);
  GetCommModemStatus (ComH,m);
  if m and MS_CTS_ON>0 then w:=w+(1 shl i);
  ClearCommBreak(ComH);
 end;
 AC:=w;
end;

function DoFactor(NotUsed:pointer):integer;
begin
  repeat
     TablProbek[CurrPos]:=formaGlowna.AC;
    inc(CurrPos);
  until false;
end;

function DoFactorWyzwalanie(NotUsed:pointer):integer;
var
  temp : real;
begin
  repeat
  temp := FormaGlowna.ACWart(FormaGlowna.AC);
  if temp < StrToFloat(FormaGlowna.MaxUEdit.Text) then
  if temp > StrToFloat(FormaGlowna.MinUEdit.Text) then
  begin
    TablProbek[CurrPos]:=formaGlowna.AC;
    inc(CurrPos);
  end;
  until false;
end;

function TFormaGlowna.ACwart(b:byte):real;
begin
 if CheckBoxPrzeliczaj.state = cbChecked then begin
  ACwart := REF/256 * b;
 end else ACwart := b;
end;

{-----WyswietlFragment---------}
procedure TFormaGlowna.WyswietlFragment;
var x,y:integer;
begin
 caption:='TLCSCO - Oscyloskopik TLC549 v1.1 - Pozycja '+IntToStr(EditPos)+' Wartosc='+ Format('%f', [ACwart(TablProbek[EditPos])]);
 Application.title:=Format('%f', [ACwart(TablProbek[EditPos])]);
{wyczysc i wymaluj kraty}
 imageOsc.Canvas.Brush.Color := clGreen;
 imageOsc.Canvas.Brush.Style := bsCross;
 with imageOsc.Canvas do FillRect(rect(1,1,ClientWidth,ClientHeight));

{wyswietl fragment}
 imageOsc.canvas.pen.color:=clRed;
 imageOsc.canvas.moveTo(1,TablProbek[EditPos]);
 for x:=0 to imageOsc.ClientWidth do begin
  if EditPos-x<0 then break;
  y:=ImageOsc.ClientHeight-TablProbek[EditPos-x];
  imageOsc.canvas.lineTo(x,y);
 end;
end;

{----Scroll---------}
procedure TFormaGlowna.ScrollBarOscChange(Sender: TObject);
begin
 EditPos:=ScrollbarOsc.Position;
 WyswietlFragment;
end;

{-------TIMER odczytujacy probki--------}
procedure TFormaGlowna.Timer1Timer(Sender: TObject);
var
  temp : real;
  temp2 : byte;
begin
     //MinUEdit.Text := Format('%d', [AC]);
     //MaxUEdit.Text := Format('%f', [AC * REF / 256]);
  TimerPokazujacy.Enabled := false;
  temp2 := AC;
  if CheckBoxPrzeliczaj.state = cbChecked then temp := REF / 256 * temp2
  else temp := temp2;
  if wyzwalanie = true then
  begin
    if temp < StrToFloat(MaxUEdit.Text) then
    if temp > StrToFloat(MinUEdit.Text) then
    begin
     TablProbek[CurrPos] := temp2;
     TablCzasow[CurrPos] := TablCzasow[CurrPos-1] + SpinEditFreq.value;
     EditPos := CurrPos;
     WyswietlFragment;
     inc(CurrPos);
    end;
  end else
  begin
      TablProbek[CurrPos] := temp2;
     TablCzasow[CurrPos] := TablCzasow[CurrPos-1] + SpinEditFreq.value;
     EditPos := CurrPos;
     WyswietlFragment;
     inc(CurrPos);
  end;
end;

{---------START---------}
procedure TFormaGlowna.ButtonStartClick(Sender: TObject);
begin

 buttonStart.enabled:=false;
 buttonStop.enabled:=true;
 ButtonExport.enabled:=false;
 ScrollBarOsc.enabled:=false;
 SpinEditFreq.enabled:=false;
 CheckBoxMaxFreq.enabled:=false;

 //wyzwalanie
 MinUEdit.enabled:=false;
 MaxUEdit.enabled:=false;
 TriggerCheckBox.enabled:=false;

 timer1.interval:=SpinEditFreq.Value;
 if CheckBoxMaxFreq.state=cbUnchecked then timer1.enabled:=true else
  begin
   if wyzwalanie = false then
   TH:=CreateThread(nil, 0, @DoFactor, nil, 0, THID)
   else TH:=CreateThread(nil, 0, @DoFactorWyzwalanie, nil, 0, THID);
   StartTime:=time;
   BierzacaLprobek:=CurrPos;
   TimerPokazujacy.enabled:=true;
  end;
end;

{--------STOP--------------}
procedure TFormaGlowna.ButtonStopClick(Sender: TObject);
var
 h,m,s,ss:word;
 t:word;
 i:longint;
begin
 timer1.enabled:=false;
 //timerPokazujacy.enabled:=false;
 if CheckBoxMaxFreq.state=cbChecked then begin {Obliczanie czasu}
  decodeTime(time-StartTime,h,m,s,ss);
  TerminateThread(TH, 0);
  CloseHandle(TH);
  t:=(ss+s*1000+m*60*1000) div ((CurrPos-BierzacaLprobek) + 1);
  for i:=BierzacaLprobek to CurrPos do tablCzasow[i]:=t*(i-BierzacaLprobek+1);
 end;

 dec(CurrPos); {Bo w timerze zostala zwiekszona o 1}
 buttonStop.enabled:=false;
 buttonStart.enabled:=true;
 ButtonExport.enabled:=true;
 ScrollBarOsc.enabled:=true;
 SpinEditFreq.enabled:=true;
 CheckBoxMaxFreq.enabled:=true;
 ScrollBarOsc.max:=CurrPos;
 ScrollBarOsc.position:=CurrPos;

  //wyzwalanie
 TriggerCheckBox.Enabled := true;
 if TriggerCheckBox.State = cbChecked then
 begin
  MinUEdit.enabled  := true;
  MaxUEdit.enabled  := true;
  Label1.enabled    := true;
  Label2.enabled    := true;
 end;
end;

{--------Create------}
procedure TFormaGlowna.FormCreate(Sender: TObject);
begin
 FillChar(TablProbek,sizeof(TablProbek),0);
 FillChar(TablCzasow,sizeof(TablCzasow),0);
 WyswietlFragment;
 wyzwalanie := false;
end;

{-------Export--------}
procedure TFormaGlowna.ButtonExportClick(Sender: TObject);
var
 f:TextFile;
 i:longint;
begin
 if not SaveDialog1.Execute then exit;
 assignFile(f,SaveDialog1.FileName);
 rewrite(f);
 writeln(f,'Czas [ms]   Wartosc');
 for i:=0 to CurrPos do writeln(f,TablCzasow[i]:8,Format('%f', [ACwart(TablProbek[i])]):8);
 CloseFile(f);
end;

{-----O-----}
procedure TFormaGlowna.ButtonAboutClick(Sender: TObject);
begin
 FormO.Top:=FormaGlowna.top+100;
 FormO.Left:=FormaGlowna.left+100;
 FormO.show;
end;

{-----TIMER Pokazujacy----}
procedure TFormaGlowna.TimerPokazujacyTimer(Sender: TObject);
begin
 EditPos:=CurrPos;
 WyswietlFragment;
end;

procedure TFormaGlowna.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  CloseHandle(ComH);
end;

{-------OK NA WSTEPIE-------}
procedure TFormaGlowna.ButtonOKClick(Sender: TObject);
var
 i:integer;
begin
 if CheckBoxPrzeliczaj.state=cbChecked then begin
  val(editPrzeliczaj.text,REF,i);
  if (i<>0)or(REF<0)or(REF>6) then begin
   MessageDlg('Podales niepoprawna wartosc napiecia REF+ lub z poza zakresu 0<REF<6', mtError,[mbOk], 0);
   exit;
  end;
 end;
{Otwarcie portu}
 ComH:=CreateFile(PChar(ComboBoxPort.text),GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,0,0 );
{ funkcja zwraca w przypadku powodzenia uchwyt portu, natomiast jeli co nie wyjdzie - warto INVALID_HANDLE_VALUE ( -1) }
 if (ComH = INVALID_HANDLE_VALUE ) then begin
  MessageDlg('Nie moge otworzyc portu '+ComboBoxPort.text, mtError,[mbOk], 0);
  exit;
 end;
{ tu mona te wywoa funkcj GetLastError eby sprawdzi, co byo przyczyn - w uproszczonej praktyce takie sprawdzanie z powodzeniem pomijamy }
{ dodatkowo moemy sprawdzi, czy uzyskany uchwyt jest waciwy dla portu - urzdzenia znakowego}
 if ( GetFileType ( ComH ) <> FILE_TYPE_CHAR ) then begin
  MessageDlg('Nie moge otworzyc portu '+ComboBoxPort.text, mtError,[mbOk], 0);
  exit;
 end;
 EscapeCommFunction(ComH,SETRTS);
{ wszystko poprawne - wic : }
 GroupBoxSelPort.Hide;
 ButtonStart.enabled:=true;
 if CheckBoxPrzeliczaj.state = cbChecked then
 MaxUEdit.Text := Format('%f', [REF])
 else MaxUEdit.Text := '255';
end;

procedure TFormaGlowna.TriggerCheckBoxClick(Sender: TObject);
begin
 if TriggerCheckBox.State = cbChecked then
 begin
  MinUEdit.enabled  := true;
  MaxUEdit.enabled  := true;
  Label3.enabled    := true;
  Label2.enabled    := true;
  wyzwalanie := true;
 end else
 begin
  MinUEdit.enabled  := false;
  MaxUEdit.enabled  := false;
  Label3.enabled    := false;
  Label2.enabled    := false;
  wyzwalanie := false;
 end;
end;

end.
